##########################################################################################
################################## SOFTWARE R - CAST 4 ###################################
##########################################################################################

# Nastaveni pracovniho adresare - napr.:
setwd("c:/Users/janousova/Documents/Vyuka/DSAN01 - Analyza dat pro neurovedy/2013 jaro/Materialy/Rko")


############### Nacteni dat a jejich zobrazeni ###############

kardio <- read.table(file="Data_pro_R.txt", sep="\t", dec=".", header=T) # nacteni dat

ls(package:stats)                 # vypsani vsech funkci knihovny "stats"

### Vytvoreni validniho souboru - vsichni pacienti museji mit vyplneny vek a systolicky tlak:
dim(kardio)
sum(is.na(kardio$vek))            # v souboru neni zadny pacient s nevyplnenym vekem
sum(is.na(kardio$sys_tlak))       # v souboru neni zadny pacient s nevyplnenym systolickym tlakem
#kardio <- kardio[!is.na(kardio$vek),] # odstraneni pacientu s nevyplnenym vekem

### Rekategorizace veku:
kardio$vek.3kat <- 1+(kardio$vek>=30)+(kardio$vek>=50) # vytvoreni trech kategorii: 1...<30, 2...30-50, 3...>=50 
table(kardio$vek.3kat,useNA="ifany") # frekvencni tabulka 


############### ANOVA ################

### 1. Overeni normality:

# 1.1 histogram:
windows()
par(mfrow=c(1,3))                 # nastaveni vykresleni 3 grafu do 1 okna
hist(kardio$sys_tlak[kardio$vek.3kat==1])
hist(kardio$sys_tlak[kardio$vek.3kat==2])
hist(kardio$sys_tlak[kardio$vek.3kat==3])
# Normalita neni splnena! ANOVA by se nemela pocitat - tyhle skripty jsou jen na ukazku, jak se funkce volaji!!!

# 1.2 boxplot:
par(mfrow=c(1,1))
boxplot(kardio$sys_tlak~kardio$vek.3kat)

# 1.3 Q-Q graf:
par(mfrow=c(1,3))                 # nastaveni vykresleni 3 grafu do 1 okna
qqnorm(kardio$sys_tlak[kardio$vek.3kat==1])
qqnorm(kardio$sys_tlak[kardio$vek.3kat==2])
qqnorm(kardio$sys_tlak[kardio$vek.3kat==3])

# 1.4 Shapiruv-Wilkuv test - doporucovan pro mensi vzorky, muze byt moc prisny pro velke vzorky:
shapiro.test(kardio$sys_tlak[kardio$vek.3kat==1])
shapiro.test(kardio$sys_tlak[kardio$vek.3kat==2])
shapiro.test(kardio$sys_tlak[kardio$vek.3kat==3])


### 2. Overeni homogenity rozptylu:

# 2.1 Histogram, boxplot - viz overeni normality

# 2.2 Bartlettuv test (srovnani homogenity rozptylu vice nez dvou vyberu z normalniho rozdeleni):
bartlett.test(sys_tlak~vek.3kat,data=kardio) 
# Bartlettuv test predpoklada normalitu puvodnich hodnot!!!!

# 2.3 Levenuv test:
Levene <- function(y,skupina){
skupina <- as.factor(skupina) # preventivni prevedeni na faktor
meds <- tapply(y, skupina, median)
resp <- abs(y - meds[skupina])
anova(lm(resp ~ skupina))[1, 4:5]
}
Levene(kardio$sys_tlak,kardio$vek.3kat) # zavolani vytvorene funkce

# Ani rozptyl neni homogenni! ANOVA by se nemela pocitat - tyhle skripty jsou jen na ukazku, jak se funkce volaji!!!


### ANOVA:
anova.test <- anova(lm(sys_tlak~vek.3kat,data=kardio)) # je potreba nejdriv vytvorit linearni model pomoci lm
anova.test
anova.tabulka <- as.matrix(anova.test)
anova.tabulka
anova.tabulka[1,5]                # vypsani p-hodnoty  

# 2. zpusob: 
anova.test <- aov(sys_tlak~vek.3kat,data=kardio)
summary(anova.test)

# zjisteni, ktere skupiny se od sebe lisi:
pairwise.t.test(kardio$sys_tlak,kardio$vek.3kat,p.adj="bonferroni")

# Ukol: zjistete, ktere dalsi metody korekce p-hodnoty existuji:

# Reseni:
? pairwise.t.test
? p.adjust

tukey_hsd <- TukeyHSD(aov(kardio$sys_tlak~as.factor(kardio$vek.3kat)))
tukey_hsd


################ Kruskaluv - Wallisuv test ###################

kruskal.test(sys_tlak~vek.3kat,data=kardio)


